//
//  MedtechAnalysis.cc
//  medtech
//
//  Created by Baranyai David on 2018. 04. 03..
//

#include "MedtechAnalysis.hh"

MedtechAnalysis::MedtechAnalysis()
{
    tree = new TTree("tree", "tree");
    file = new TFile("data.root","RECREATE");
    instance = this;
    MedtechAnalysisMutex = G4MUTEX_INITIALIZER;
}

MedtechAnalysis::~MedtechAnalysis()
{
    
}

MedtechAnalysis* MedtechAnalysis::getInstance()
{
    if (instance == 0)
    {
        instance = new MedtechAnalysis();
    }
    
    return instance;
}

void MedtechAnalysis::Fill(double x, double y, double e)
{
    G4AutoLock lock(&MedtechAnalysisMutex);
    tree -> Branch("x", &x, "x/D");
    tree -> Branch("y", &y, "y/D");
    tree -> Branch("e", &e, "e/D");
    
    tree -> Fill();
    
    lock.unlock();
}

void MedtechAnalysis::Close()
{
    tree -> Write();
    file -> Close();
}

/* Null, because instance will be initialized on demand. */
MedtechAnalysis* MedtechAnalysis::instance = 0;
